﻿using SfDataGrid_Demo.Service_References.ServiceReference1;
using Simple.OData.Client;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using System.Reflection;

namespace SfDataGrid_Demo
{
    public class ViewModel:INotifyPropertyChanged
    {       
        #region Properties

        private ObservableCollection<Order> gridSource;
        public ObservableCollection<Order> GridSource
        {
            get { return gridSource; }
            set { gridSource = value; RaisePropertyChanged("GridSource"); }
        }

        #endregion

        #region Ctor

        public ViewModel()
        {
            gridSource = new ObservableCollection<Order>();
            try
            {
                Device.BeginInvokeOnMainThread(() =>
                {
                    LoadData();
                });

            }
            catch (Exception e)
            {
                throw e;
            }
        }

        #endregion

        #region Methods     
        async void LoadData()
        {
            gridSource = new ObservableCollection<Order>();            
            var client = new ODataClient("http://services.odata.org/Northwind/Northwind.svc/");
            var units = await client.FindEntriesAsync("Orders");
            var itemCollection = units.ToList();
            Device.BeginInvokeOnMainThread(() =>
            {
                foreach (var item in itemCollection)
                {
                    var order = new Order();
                    foreach (var prop in item)
                    {
                        order.GetType().GetRuntimeProperty(prop.Key).SetValue(order, prop.Value);
                    }
                    gridSource.Add(order);
                }
            });
        }

        #endregion

        #region INotifyPropertyChanged Member

        public event PropertyChangedEventHandler PropertyChanged;

        void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion
    }
}
